#pragma once
//*****************************************************************************************************
//  1. t@C
//		ArrayEx.h
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CArrayEx,CArrayEx2,CIntArrayEx,CStringArrayEx NX̃C^[tFCX
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************

// CArrayNX̊givfǉ@\tj
template< class TYPE, class ARG_TYPE >
class CArrayEx : public CArray < TYPE, ARG_TYPE >
{
public:
	// vfPǉẴ|C^ƃCfbNXԂ
	TYPE *AddElement(int &nIndex)
	{
		nIndex = GetSize();
		SetSize(nIndex + 1);
		return &ElementAt(nIndex);
	}

	// vfPǉẴ|C^Ԃ
	TYPE *AddElement()
	{
		int nIndex;
		return AddElement(nIndex);
	}

	CArrayEx& operator=(const CArrayEx& other) {
		Copy(other);
		return *this;
	}
};

// CArrayNX̊gi@\tj
template< class TYPE, class ARG_TYPE >
class CArrayEx2 : public CArray < TYPE, ARG_TYPE >
{
protected:
	// pCMap
	CMap <CString, LPCTSTR, int, int> m_cMap;

public:
	// vfPǉẴ|C^ƃCfbNXԂ
	TYPE *AddElement(LPCTSTR pKey, int &nIndex)
	{
		CString sKey(pKey);
		sKey.MakeLower();
		nIndex = GetSize();
		SetSize(nIndex + 1);
		m_cMap.SetAt(sKey, nIndex);
		return &ElementAt(nIndex);
	}

	// vfPǉẴ|C^Ԃ
	TYPE *AddElement(LPCTSTR pKey)
	{
		int nIndex;
		return AddElement(pKey, nIndex);
	}

	// L[āA炻̃|C^ƃCfbNXԂ
	TYPE *LookupElement(LPCTSTR pKey, int &nIndex)
	{
		CString sKey(pKey);
		sKey.MakeLower();
		if (m_cMap.Lookup(sKey, nIndex))
			return &ElementAt(nIndex);
		else
			return NULL;
	}

	// L[āA炻̃|C^Ԃ
	TYPE *LookupElement(LPCTSTR pKey)
	{
		int nIndex;
		return LookupElement(pKey, nIndex);
	}

	// SĂ̗vf폜
	void RemoveAll()
	{
		m_cMap.RemoveAll();
		CArray< TYPE, ARG_TYPE >::RemoveAll();
	}

// --Add 2007/03/02 aizawa sD-147
	// L[ύX
	void ChangeKey(LPCTSTR pKeyOld, LPCTSTR pKeyNew)
	{
		int nIndex;
		CString sKey(pKeyOld);
		sKey.MakeLower();
		if (m_cMap.Lookup(sKey, nIndex)) {
			m_cMap.RemoveKey(sKey);
			sKey = pKeyNew;
			sKey.MakeLower();
			m_cMap.SetAt(sKey, nIndex);
		}
	}
// --Add

	CArrayEx2& operator=(const CArrayEx2& other) {
		Copy(other);
		m_cMap.RemoveAll();
		CString sKey;
		int nIndex;
		for (POSITION pos = other.m_cMap.GetStartPosition(); pos != NULL; ) {
			other.m_cMap.GetNextAssoc(pos, sKey, nIndex);
			m_cMap.SetAt(sKey, nIndex);
		}
		return *this;
	}
};

// zNX̊g
class CIntArrayEx : public CArray < int, int >
{
public:
	void Unique();
	void Sort();
	int Find(int n);
	int AddUnique(int n);

	CIntArrayEx& operator=(const CIntArrayEx& other) {
		Copy(other);
		return *this;
	}

protected:
	static int CompareSort(const void *arg1, const void *arg2);
};

// zNX̊g
class CStringArrayEx : public CStringArray
{
public:
	void Unique();
	int Find(LPCTSTR pStr);
	int AddUnique(LPCTSTR pStr);
	CString Join(LPCTSTR pDelimiter);
	void Split(LPCTSTR pDelimiter, const CString &sText);

	CStringArrayEx& operator=(const CStringArrayEx& other) {
		Copy(other);
		return *this;
	}
};
